{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2001
  Versión actual: 1.0.0
  Fecha versión actual: 01-10-2001
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit BuscarArticuloObraHistorica;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, IBQuery, StdCtrls, DB, RdxBotones,  RdxBarras, RdxComboBox,
  RdxCampos,  RdxTitulos, RdxPaneles, Tipos, Mensajes,
  RdxFrame, RdxDBFrame, RdxFrameArticulosObraHistorica,
  RdxFrameArticulosAlmacen;


type
  TfrBuscarArticuloObraHistorica = class(TRdxFrameArticulosObraHistorica)
    brBuscar: TRdxBarraInferior;
    bBuscar: TRdxBoton;
    bCerrar: TRdxBoton;
    RdxPanel1: TRdxPanel;
    RdxCabecera1: TRdxCabecera;
    eCodigo: TLabel;
    eFamilia: TLabel;
    eDescripcion: TLabel;
    Codigo: TRdxEdit;
    cbxFamilia: TRdxComboBox;
    Descripcion: TRdxEdit;
    procedure bCerrarClick(Sender: TObject);
    procedure bBuscarClick(Sender: TObject);
    procedure RecogerDatos;
  protected
    procedure BuscarArticulo; override;
    procedure BuscarAlmacen; override;
    function CloseFrame : boolean; override;
  public
    constructor Create (AOwner : TComponent); override;
  published
    property TablaArticulosObraHistorica;
    property CodigoAlmacen;
    property CodigoArticulo;
  end;

var
  frBuscarArticuloObraHistorica: TfrBuscarArticuloObraHistorica;

implementation

{$R *.DFM}

uses
  BaseDatos, ArticulosObraHistorica, TablaFamilias, Configuracion,
  Literales;

var
  Campos : String;
  Valores : Variant;
  Contador : Integer;

constructor TfrBuscarArticuloObraHistorica.Create (AOwner : TComponent);
begin
  if not (AOwner is TRdxFrameArticulosObraHistorica) then
    exit;
  inherited Create(AOwner);
  Entidad := entArticulosObraHistorica;
  ConfigurarFrame(Self, Self.Entidad);

  Contador := -1;
  Campos := '';
  Valores := VarArrayOf([null, null, null]);

  cbxFamilia.Items := dmTablaFamilias.darFamilias;
  TablaArticulosObraHistorica := (AOwner as TRdxFrameArticulosObraHistorica).TablaArticulosObraHistorica;
  with TablaArticulosObraHistorica do begin
    Codigo.MaxLength := FieldByName('CODIGOARTICULO').Size;
    Descripcion.MaxLength := FieldByName('DESCRIPCION').Size;
  end;
end;

procedure TfrBuscarArticuloObraHistorica.bCerrarClick(Sender: TObject);
begin
  inherited;
  CloseFrame;
end;

procedure TfrBuscarArticuloObraHistorica.RecogerDatos;
begin
  Campos := '';
  Contador := -1;

  if Length(Trim(Codigo.Text)) > 0 then
  begin
    Contador := Contador + 1;
    Campos := Campos + 'CODIGOARTICULO';
    Valores[Contador] := Trim(Codigo.Text);
  end;

  if Length(Trim(Descripcion.Text)) > 0 then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'DESCRIPCION';
    Valores[Contador] := Trim(Descripcion.Text);
  end;

  if Length(Trim(cbxFamilia.Text)) > 0 then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'FAMILIA';
    Valores[Contador] := Trim(cbxFamilia.Text);
  end;
end;

procedure TfrBuscarArticuloObraHistorica.bBuscarClick(Sender: TObject);
begin
  RecogerDatos;
  if Contador <> -1 then
    BuscarArticulo
  else
    VerMensaje(msgNoParametros);
end;

procedure TfrBuscarArticuloObraHistorica.BuscarArticulo;
var
  Respuesta : integer;
  Resultado : Boolean;
begin
  if Contador <> -1 then begin
    TablaArticulosObraHistorica.DisableControls;

    if Contador = 0
    then Resultado := TablaArticulosObraHistorica.LocateNext(Campos, Valores[Contador], [loCaseInsensitive, loPartialKey])
    else Resultado := TablaArticulosObraHistorica.LocateNext(Campos, Valores, [loCaseInsensitive, loPartialKey]);
    if (Resultado = false) then
    begin
        Respuesta := VerMensajePregunta(msgIrInicio);
        case Respuesta of
          IDYES: TablaArticulosObraHistorica.First;
        end;
    end;
    TablaArticulosObraHistorica.EnableControls;
  end;
end;

procedure TfrBuscarArticuloObraHistorica.BuscarAlmacen;
begin
//
end;

function TfrBuscarArticuloObraHistorica.CloseFrame: boolean;
begin
//  FCodigoAlmacen := TablaArticulosObraHistorica.FieldByName('CODIGOOBRA').AsString;
  FCodigoArticulo := TablaArticulosObraHistorica.FieldByName('CODIGOARTICULO').AsString;
  Result := inherited CloseFrame;
end;

end.
